#include <cstdio>
#include <string>

using std::FILE;
using std::string;

#include "autoptr"
struct BufferData: public ptrable
{
    char *data;
    unsigned size;
public:
    ~BufferData();
    
    static void* operator new(unsigned size);
    static void operator delete(void *obj, unsigned size);
};
class BufferType
{
    autoptr<BufferData> data;
public:
    BufferType(unsigned size);
    BufferType(unsigned size, char c);
    
    BufferType(const char*b,          const char*e);
    BufferType(const unsigned char*b, const unsigned char*e);
    
    inline char& operator[] (unsigned ind) { return data->data[ind]; }
    inline const char& operator[] (unsigned ind) const { return data->data[ind]; }
    inline unsigned size() const { return data->size; }
};

extern void AddWriteTask(FILE *fp, const BufferType& data);
extern void UpdateBuffers();
extern void FlushBuffers();

extern const string GetBufferStatus();

/* return true if the time was elapsed properly */
extern bool BufferElapse(double nseconds);

extern bool BufferWaitInput();

/* This is to be defined in main module */
extern void BufferEmptied(FILE *fp);
